/**
 * Class representing the Complex timeline.
 *
 * Made with Flow
 */
class Complex {
    /**
     * Returns the timeline's duration in milliseconds.
     */
    static get duration() { return 2000 }

    static artboardAnimation() {
        // Workaround for Safari bug
        return document.querySelector('#Complex.flow-artboard').animate({
            backgroundPosition: ['0px', '1px'],
        }, {
            delay: 0,
            duration: 2000,
        });
    }
    static redTransformAnimation() {
        return document.querySelector('#Complex .red').animate([
            { transform: 'translate(-50%, -50%) rotate(0deg)', offset: 0, easing: 'ease-in-out' },
            { transform: 'translate(-50%, -50%) rotate(45deg)', offset: 0.1, easing: 'ease-in-out' },
            { transform: 'translate(-50%, -50%) rotate(90deg)', offset: 0.265, easing: 'ease-in-out' },
            { transform: 'translate(-50%, -50%) rotate(180deg)', offset: 0.75, easing: 'ease-in-out' },
            { transform: 'translate(-50%, -50%) rotate(0deg)', offset: 1 },
        ], {
            duration: Complex.duration,
            composite: 'add',
            fill: 'forwards'
        });
    }
    static redAnimation0() {
        return document.querySelector('#Complex .red').animate({
            width: ['100px', '159.13px'],
            top: ['188px', '120.71px'],
            height: ['100px', '159.13px'],

        }, {
            delay: 0,
            duration: 200,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redAnimation1() {
        return document.querySelector('#Complex .red').animate({
            left: ['68px', '184.23px'],

        }, {
            delay: 0,
            duration: 530,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redAnimation2() {
        return document.querySelector('#Complex .red').animate({
            top: ['120.71px', '216.17px'],

        }, {
            delay: 200,
            duration: 330,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redAnimation3() {
        return document.querySelector('#Complex .red').animate({
            width: ['159.13px', '31.59px'],
            height: ['159.13px', '31.59px'],

        }, {
            delay: 200,
            duration: 650,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redAnimation4() {
        return document.querySelector('#Complex .red').animate({
            top: ['216.17px', '120.47px'],
            left: ['184.23px', '258.08px'],

        }, {
            delay: 530,
            duration: 320,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redAnimation5() {
        return document.querySelector('#Complex .red').animate({
            width: ['31.59px', '100px'],
            height: ['31.59px', '100px'],

        }, {
            delay: 850,
            duration: 1150,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redAnimation6() {
        return document.querySelector('#Complex .red').animate({
            top: ['120.47px', '296.66px'],
            left: ['258.08px', '294.34px'],

        }, {
            delay: 850,
            duration: 650,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redAnimation7() {
        return document.querySelector('#Complex .red').animate({
            top: ['296.66px', '188px'],
            left: ['294.34px', '68px'],

        }, {
            delay: 1500,
            duration: 500,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redShapeAnimation0() {
        return document.querySelector('#Complex .red-svg').animate({
            strokeWidth: ['10px', '20px'],

        }, {
            delay: 0,
            duration: 850,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redShapeAnimation1() {
        return document.querySelector('#Complex .red-svg').animate({

        }, {
            delay: 0,
            duration: 200,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redShapeAnimation2() {
        return document.querySelector('#Complex .red-svg').animate({
            fill: ['#FD0178', '#2062FF'],

        }, {
            delay: 0,
            duration: 530,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redShapeAnimation3() {
        return document.querySelector('#Complex .red-svg').animate({

        }, {
            delay: 200,
            duration: 330,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redShapeAnimation4() {
        return document.querySelector('#Complex .red-svg').animate({

        }, {
            delay: 200,
            duration: 650,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redShapeAnimation5() {
        return document.querySelector('#Complex .red-svg').animate({

        }, {
            delay: 530,
            duration: 320,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redShapeAnimation6() {
        return document.querySelector('#Complex .red-svg').animate({
            fill: ['#2062FF', '#FD0178'],

        }, {
            delay: 530,
            duration: 1470,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redShapeAnimation7() {
        return document.querySelector('#Complex .red-svg').animate({

        }, {
            delay: 530,
            duration: 970,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redShapeAnimation8() {
        return document.querySelector('#Complex .red-svg').animate({

        }, {
            delay: 850,
            duration: 650,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redShapeAnimation9() {
        return document.querySelector('#Complex .red-svg').animate({
            strokeWidth: ['20px', '10px'],

        }, {
            delay: 850,
            duration: 1150,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }
    static redShapeAnimation10() {
        return document.querySelector('#Complex .red-svg').animate({

        }, {
            delay: 1500,
            duration: 500,
            easing: 'ease-in-out',
            composite: 'add',
            fill: 'forwards',
        });
    }

    /**
     * Creates and returns all animations for this timeline.
     */
    static createAllAnimations() {
        return [
            this.artboardAnimation(),
            this.redTransformAnimation(),
            this.redAnimation0(),
            this.redAnimation1(),
            this.redAnimation2(),
            this.redAnimation3(),
            this.redAnimation4(),
            this.redAnimation5(),
            this.redAnimation6(),
            this.redAnimation7(),
            this.redShapeAnimation0(),
            this.redShapeAnimation1(),
            this.redShapeAnimation2(),
            this.redShapeAnimation3(),
            this.redShapeAnimation4(),
            this.redShapeAnimation5(),
            this.redShapeAnimation6(),
            this.redShapeAnimation7(),
            this.redShapeAnimation8(),
            this.redShapeAnimation9(),
            this.redShapeAnimation10(),
        ]
    }
}

Complex.allShapes = [
    document.querySelector("#Complex .red-svg"),
]

Object.freeze(Complex)
