/**
 * Class representing the NoMovement timeline.
 *
 * Made with Flow
 */
class NoMovement {
    /**
     * Returns the timeline's duration in milliseconds.
     */
    static get duration() { return 1000 }

    static artboardAnimation() {
        // Workaround for Safari bug
        return document.querySelector('#NoMovement.flow-artboard').animate({
            backgroundPosition: ['0px', '1px'],
        }, {
            delay: 0,
            duration: 1000,
        });
    }

    /**
     * Creates and returns all animations for this timeline.
     */
    static createAllAnimations() {
        return [
            this.artboardAnimation(),
        ]
    }
}

NoMovement.allShapes = [
    document.querySelector("#NoMovement .red-svg"),
]

Object.freeze(NoMovement)
